#!/usr/bin/env perl
# (c) Deep IT, Uncle MiF, 2003-2010, mac_support@realsofts.com

require 5.8.0;
use strict;

our $modules;
BEGIN
{	
	select STDIN;
	$| = 1;
	select STDOUT;
	$| = 1;
	$modules = __FILE__;
	$modules = '.' if ($modules !~ /\//);
	$modules =~ s/\/[^\/]*$//gos;
 my $pmodules = $modules;
 $pmodules =~ s/'/\\'/gos;
 eval "use lib ('$pmodules');";
}
use lib qw(.);
use Localization::Localization;
use DBUtil;

print "\n";
if (scalar(@ARGV) != 1)
{
	my $verPath = $0; 
	$verPath =~ s/\/[^\/]*$//gos;
	$verPath .= '/version';
	my $ver = readFile($verPath);
	$ver =~ s/\s+$//gos;
	print _L("(c) MiF, TranslateIt!, Stardict/Freedict dictionary entries delete version %#\n\n",$ver);
	print _L("Usage: %# <dictionaryName>\n",$0);
	print _L("\n<dictionaryName> - dictionary path and file name without extension\n");
	print _L("\nExample: %# ~/Library/Application\\ Support/TranslateIt\\!/en-fr-simple\n",$0);
	print _L("(no .dict or .idx extension needed, however, en-fr-simple.idx & .dict (fr-ru-synt.idx for the second example) files must be present at specified location)\n\n");
	exit(1);
}

my $fName = $ARGV[0];

$fName =~ s/\.dict$//i;
$fName =~ s/\.idx$//i;

my $IDX = $fName.".idx";
if (! -f $IDX)
{
	print _L("%# not found\n",$IDX);
	exit(3);
}

my $DICT = $fName.".dict";
if (! -f $DICT)
{
	print _L("%# not found\n",$DICT);
	exit(3);
}

print _L("Processing dictionary...\n");

local * fI;
local * fD;

open(fI,"<$IDX") or die _L("Can't open file %#", $IDX);
my $iContent;
seek(fI,0,2);
my $iSize = tell(fI);
seek(fI,0,0);
print _L("Index readed: %# from %#\n", read(fI,$iContent,$iSize), $iSize);
close(fI);

open(fD,"<$DICT") or die _L("Can't open file %#", $DICT);
my $dContent;
seek(fD,0,2);
my $dSize = tell(fD);
seek(fD,0,0);
print _L("Dictionary readed: %# from %#\n", read(fD,$dContent,$dSize), $dSize);
close(fD);

my $answer;
my ($iPrev,$dPrev,$iShift,$dShift) = (0,0,0,0);
do
{
	print _L("\nMenu: 0 - write and exit, 1 - delete entry: ");
	$answer = <STDIN>;
	$answer =~ s/\D+//gos;
	if ($answer eq '1')
	{
		my ($dOffset, $dLength, $iOffset, $iLength);

		print _L("Index offset: ");
		$iOffset = <STDIN>;
		$iOffset =~ s/\D+//gos;
		$iOffset = 0 + $iOffset;

		print _L("Index length: ");
		$iLength = <STDIN>;
		$iLength =~ s/\D+//gos;
		$iLength = 0 + $iLength;

		print _L("Dictionary offset: ");
		$dOffset = <STDIN>;
		$dOffset =~ s/\D+//gos;
		$dOffset = 0 + $dOffset;

		print _L("Dictionary length: ");
		$dLength = <STDIN>;
		$dLength =~ s/\D+//gos;
		$dLength = 0 + $dLength;

		if ($dOffset && $dLength && $iOffset && $iLength && $dOffset >= $dPrev && $iOffset >= $iPrev)
		{
			print _L(" analyzing IDX %#: %#, DICT %#: %#\n",$iOffset,$iLength,$dOffset,$dLength);
			$dPrev = $dOffset;
			$iPrev = $iOffset;

			$dOffset -= $dShift;
			$iOffset -= $iShift;

			if ($iOffset >= 0 && $dOffset >= 0 && ($dOffset + $dLength) <= $dSize && ($iOffset + $iLength <= $iSize))
			{
				$dShift += $dLength;
				$iShift += $iLength;
				print _L("  removing IDX %#: %#, DICT %#: %#\n",$iOffset,$iLength,$dOffset,$dLength);
				substr($dContent,$dOffset,$dLength,'');
				substr($iContent,$iOffset,$iLength,'');
				$dSize -= $dLength;
				$iSize -= $iLength;
# fixing next indexes
				while ($iOffset < $iSize)
				{
					while (ord(substr($iContent,$iOffset,1)) != 0)
					{
						# skip word
						$iOffset++;
					}
					$iOffset++;
					if ($iOffset + 8 <= $iSize)
					{
						my ($offset, $len);
						$offset = unpack('N',substr($iContent,$iOffset,4));
						$offset -= $dLength;
						substr($iContent,$iOffset,4,pack('N',$offset));
						$iOffset += 4;
						$len = unpack('N',substr($iContent,$iOffset,4));
						$iOffset += 4;
					}
				}
				print _L("  new IDX size: %#, DICT size: %#",$iSize,$dSize)
			}
			else
			{
				print _L("Numbers out of range\n");
			}
		}
		else
		{
			print _L("Bad numbers\n");
		}
	}
} while ($answer ne '0');

print _L("Writing files...\n");

open(fI,">$IDX");
print fI $iContent;
close(fI);

open(fD,">$DICT");
print fD $dContent;
close(fD);

my $IDXC = $IDX . "c";
if (-f $IDXC)
{
	print _L("Removing Index Cache...\n");
	unlink($IDXC);
}

print _L("Done\n");
