#!/usr/bin/env perl
# (c) Deep IT, Uncle MiF, 2003-2010, mac_support@realsofts.com

require 5.8.0;
use strict;

our $modules;
BEGIN
{	
	select STDIN;
	$| = 1;
	select STDOUT;
	$| = 1;
	$modules = __FILE__;
	$modules = '.' if ($modules !~ /\//);
	$modules =~ s/\/[^\/]*$//gos;
 my $pmodules = $modules;
 $pmodules =~ s/'/\\'/gos;
 eval "use lib ('$pmodules');";
}
use lib qw(.);
use Localization::Localization;
use DBUtil;

print STDERR "\n";
if (scalar(@ARGV) != 1 && scalar(@ARGV) != 2)
{
	my $verPath = $0; 
	$verPath =~ s/\/[^\/]*$//gos;
	$verPath .= '/version';
	my $ver = readFile($verPath);
	$ver =~ s/\s+$//gos;
	print STDERR _L("(c) MiF, TranslateIt!, Stardict/Freedict dictionaries words list extractor version %#\n\n",$ver);
	print STDERR _L("Usage: %# <dictionaryName>\n",$0);
	print STDERR _L("\n<dictionaryName> - dictionary path and file name without extension\n");
	print STDERR _L("\nExample: %# ~/Library/Application\\ Support/TranslateIt\\!/en-fr-simple\n",$0);
	print STDERR _L("or: %# ~/Library/Application\\ Support/TranslateIt\\!/fr-ru-synt > list.txt\n",$0);
	print STDERR _L("(no .dict or .idx extension needed, however, en-fr-simple.idx (fr-ru-synt.idx for the second example) file must be present at specified location)\n\n");
	exit(1);
}

my $fName = $ARGV[0];
my $option;
if ($ARGV[1])
{
	$fName = $ARGV[1];
	$option = $ARGV[0];
}

$fName =~ s/\.dict$//i;
$fName =~ s/\.idx$//i;

my $IDX = $fName.".idx";
if (! -f $IDX)
{
	print STDERR _L("%# not found\n",$IDX);
	exit(3);
}

print STDERR _L("Processing dictionary...\n");
my ($ok,$offset,$word,$bt,$content,$len);
local * IDX;
unless (open(IDX,"<$IDX"))
{
	print STDERR _L("Can't open index file %# for reading.\n",$IDX);
	exit(21);
}
binmode(IDX);
undef $/;
my $count = 0;
$bt = '';
my $oCh;
my $pos = 0;
while (read(IDX,$bt,1))
{
	$oCh = unpack('C',$bt);
	$bt = pack('C',$oCh);
	if ($oCh == 0)
	{
		$count++;
		$word =~ s/^\s+//gos;
		$word =~ s/\s+$//gos;
		read(IDX,$offset,4); $offset = unpack('N',$offset);
		read(IDX,$len,4); $len = unpack('N',$len);
		my $oldPos = $pos;
		$pos = tell(IDX);
		if (length($word))
		{
			print '{Info IDX: ' . $oldPos . ' / ' . ($pos - $oldPos) . ', DICT: ' . $offset . ' / ' . $len . '} ' if ($option =~ /i/);# -i - print index position info
			print '{Position ' . ($count - 1) . '} ' if ($option =~ /n/);# -n - print index position number
			print "$word\n";
		}
		$content = $word = '';
		next;
	}
	$word .= $bt;
}

close(IDX);
print STDERR _L("Total words processed: %#\n",$count);
print STDERR _L("Done\n");
